#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>

#ifdef GCC32HACK
#include "win32gcc.h"
#endif

int main(int argc, char *argv[]) {
FILE *fl, *f;
DWORD i, d;
WORD c;
BYTE p[0x200];
  if (argc != 2) {
    return(1);
  }
  fl = fopen(argv[1], "rb");
  if (!fl) {
    return(2);
  }
  f = fopen("filedump.dat", "wb");
  /* read BPP */
  fread(&d, 4, 1, fl);
  printf("BPP: %d\n", (int) d);
  /* read TilesCount */
  fread(&c, 2, 1, fl);
  printf("TilesCount: %d\n", (int) c);
  /* for each tile */
  for (i = 0; i < c; i++) {
    /* unknown - palette number? */
    fseek(fl, 0x0002, SEEK_CUR);
    /* tiledata */
    fread(p, 1, 0x200, fl);
    fwrite(p, 1, 0x200, f);
/*    fseek(fl, 0x0200, SEEK_CUR);*/
  }
  fread(&c, 2, 1, fl);
  printf("PalettesCount: %d\n", (int) c);
  /* for each palette */
  for (i = 0; i < c; i++) {
    /* 16BPP palette? (always empty?) */
    fseek(fl, 256*2, SEEK_CUR);
    /* not sure this two values should be here */
    /* unknown val1 */
    fseek(fl, 0x0002, SEEK_CUR);
    /* unknown val2 */
    fseek(fl, 0x0002, SEEK_CUR);
    /* 24BPP palette */
    fseek(fl, 256*3, SEEK_CUR);
  }
  printf("FileEnd: %d\n", (int) ftell(fl));

  fclose(f);
  fclose(fl);
  return(0);
}
